
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import com.java4less.microqrcode.*;

//  Micro QR Code
//  Copyright (C)
//
//  Java4Less@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material
//  - You may not copy and paste any code into external files.

public class MicroQRCodeDemo extends JFrame {
  MicroQRCode barcode = new MicroQRCode();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton btnApply = new JButton();
  JButton btnPrint = new JButton();
  JButton btnSave = new JButton();
  JButton btnExit = new JButton();
  JLabel jLabel1 = new JLabel();
  JTextField txtValue = new JTextField();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JComboBox cEncoding = new JComboBox();
  JComboBox cEC = new JComboBox();
  JComboBox cFormat = new JComboBox();
  JTextField txtMargin = new JTextField();
  JTextField txtModuleSize = new JTextField();
  JLabel jLabel13 = new JLabel();
  JComboBox cResolution = new JComboBox();
  JCheckBox chkAutoConfigurate = new JCheckBox();

  public static void main(String[] args) {

    MicroQRCodeDemo f=new  MicroQRCodeDemo();
    f.setSize(410,515);
    f.setLocation(100,100);
    f.show();
  }

  public  MicroQRCodeDemo() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    barcode.setBounds(new Rectangle(3, 5, 395, 194));
    jTabbedPane1.setToolTipText("");
    jTabbedPane1.setBounds(new Rectangle(4, 206, 393, 228));
    btnApply.setText("Apply");
    btnApply.setBounds(new Rectangle(23, 446, 79, 27));
    btnApply.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnApply_actionPerformed(e);
      }
    });
    btnPrint.setText("Print");
    btnPrint.setBounds(new Rectangle(111, 446, 79, 27));
    btnPrint.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPrint_actionPerformed(e);
      }
    });
    btnSave.setBounds(new Rectangle(200, 446, 79, 27));
    btnSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnSave_actionPerformed(e);
      }
    });
    btnSave.setText("Save");
    btnExit.setBounds(new Rectangle(291, 446, 79, 27));
    btnExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExit_actionPerformed(e);
      }
    });
    btnExit.setText("Exit");
    jLabel1.setText("Value");
    jLabel1.setBounds(new Rectangle(6, 21, 48, 17));
    jPanel2.setLayout(null);
    txtValue.setText("01234567");//"This is a QRCode");
    txtValue.setBounds(new Rectangle(55, 20, 316, 21));
    jLabel2.setText("Encoding");
    jLabel2.setBounds(new Rectangle(6, 52, 64, 17));
    jLabel4.setText("Version");
    jLabel4.setBounds(new Rectangle(6, 79, 62, 17));
    jLabel5.setText("Module size");
    jLabel5.setBounds(new Rectangle(6, 140, 76, 17));
    jLabel6.setText("Correction level");
    jLabel6.setBounds(new Rectangle(208, 50, 91, 17));
    jLabel8.setText("Margin");
    jLabel8.setBounds(new Rectangle(209, 146, 41, 17));
    jPanel3.setLayout(null);
    cEncoding.setBounds(new Rectangle(75, 51, 126, 21));
    cEC.setBounds(new Rectangle(307, 51, 66, 21));
    cFormat.setBounds(new Rectangle(75, 81, 125, 21));
    txtMargin.setText("30");
    txtMargin.setBounds(new Rectangle(308, 144, 63, 21));
    txtModuleSize.setText("4");
    txtModuleSize.setBounds(new Rectangle(121, 138, 78, 21));
    jLabel13.setBounds(new Rectangle(8, 152, 119, 17));
    jLabel13.setText("Printer Resolution");
    cResolution.setBounds(new Rectangle(128, 151, 85, 21));
    cResolution.setBounds(new Rectangle(121, 168, 79, 21));
    jLabel13.setText("Printer Resolution");
    jLabel13.setBounds(new Rectangle(6, 169, 112, 17));
    this.setTitle("Micro QRCode demo");
    chkAutoConfigurate.setText("Autoconfigurate    ");
    chkAutoConfigurate.setHorizontalTextPosition(SwingConstants.LEADING);
    chkAutoConfigurate.setBounds(new Rectangle(210, 79, 149, 25));
    this.getContentPane().add(jTabbedPane1, null);
    jTabbedPane1.add(jPanel2, "Micro QRCode");
    jPanel2.add(jLabel1, null);
    jPanel2.add(txtValue, null);
    jPanel2.add(jLabel2, null);
    jPanel2.add(cEncoding, null);
    jPanel2.add(cFormat, null);
    jPanel2.add(jLabel4, null);
    jPanel2.add(cEC, null);
    jPanel2.add(jLabel6, null);
    jPanel2.add(txtModuleSize, null);
    jPanel2.add(jLabel5, null);
    jPanel2.add(jLabel13, null);
    jPanel2.add(cResolution, null);
    jPanel2.add(chkAutoConfigurate, null);
    jPanel2.add(txtMargin, null);
    jPanel2.add(jLabel8, null);
    

    this.getContentPane().add(barcode, null);
    this.getContentPane().add(btnExit, null);
    this.getContentPane().add(btnSave, null);
    this.getContentPane().add(btnPrint, null);
    this.getContentPane().add(btnApply, null);

    this.cEncoding.addItem("AUTO");
    this.cEncoding.addItem("BYTE");
    this.cEncoding.addItem("NUMERIC");
    this.cEncoding.addItem("ALPHA");
    this.cEncoding.addItem("KANJI");

    this.cEC.addItem("L");
    this.cEC.addItem("M");
    this.cEC.addItem("Q");

    this.cResolution.addItem("72 dpi (default)");
    this.cResolution.addItem("300 dpi");
    this.cResolution.addItem("600 dpi");

this.cFormat.addItem("1");
this.cFormat.addItem("2");
this.cFormat.addItem("3");
this.cFormat.addItem("4");


this.cFormat.setSelectedIndex(2);
this.cEC.setSelectedIndex(0);

  }

  public void show() {
    super.show();
    btnApply_actionPerformed(null);
  }

  void btnApply_actionPerformed(ActionEvent e) {

  barcode.setProcessTilde(true);

  barcode.setCode(this.txtValue.getText());

  barcode.setEncoding(barcode.ENC_AUTO);
  if (this.cEncoding.getSelectedIndex()>=0)  {
       if (((String) this.cEncoding.getSelectedItem()).equals("BYTE"))  barcode.setEncoding(barcode.ENC_BYTE);
       if (((String) this.cEncoding.getSelectedItem()).equals("ALPHA"))  barcode.setEncoding(barcode.ENC_ALPHA);
       if (((String) this.cEncoding.getSelectedItem()).equals("NUMERIC"))  barcode.setEncoding(barcode.ENC_NUMERIC);
       if (((String) this.cEncoding.getSelectedItem()).equals("KANJI"))  barcode.setEncoding(barcode.ENC_KANJI);
  }

  barcode.setPreferredVersion(1);
  if (this.cFormat.getSelectedIndex()>=0)
        barcode.setPreferredVersion(Integer.parseInt((String) this.cFormat.getSelectedItem()));



  barcode.setErrorCorrectionLevel( MicroQRCode.CORRECTION_LEVEL_L);
  if (this.cEC.getSelectedIndex()>=0)  {
       if (((String) this.cEC.getSelectedItem()).equals("Q"))  barcode.setErrorCorrectionLevel( MicroQRCode.CORRECTION_LEVEL_Q);
       if (((String) this.cEC.getSelectedItem()).equals("M"))  barcode.setErrorCorrectionLevel( MicroQRCode.CORRECTION_LEVEL_M);
  }

  barcode.setAutoConfigurate( this.chkAutoConfigurate.isSelected() );

  // remove TODO
  //barcode.setEncoding(barcode.ENC_NUMERIC);
  //barcode.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_M);
  
  
  

try {

    barcode.setModuleSize(Integer.parseInt(this.txtModuleSize.getText()));
    barcode.setMargin(Integer.parseInt(this.txtMargin.getText()));

    }
    catch (Exception ex) {}


    this.paintAll(this.getGraphics());
    this.repaint();
    barcode.setRedraw(true);
    barcode.paint(barcode.getGraphics());



  }

  void btnPrint_actionPerformed(ActionEvent e) {

   // set printer resolution
    java.awt.PageAttributes pa= new PageAttributes();

    if (this.cResolution.getSelectedIndex()==1) pa.setPrinterResolution(300);
    if (this.cResolution.getSelectedIndex()==2) pa.setPrinterResolution(600);
    //pa.setPrinterResolution(barcode.getResolution());

    // get printer job
    java.awt.PrintJob pj=Toolkit.getDefaultToolkit().getPrintJob(this,"J4L-QRCode",null,pa);

    barcode.setRedraw(true);

    java.awt.image.BufferedImage im=new java.awt.image.BufferedImage(barcode.getWidth(),barcode.getHeight(),java.awt.image.BufferedImage.TYPE_INT_RGB);
    Graphics g2=im.createGraphics();
    barcode.paint(g2);

    //    print barcode
    Graphics g= pj.getGraphics();

     g.drawImage(im,pj.getPageDimension().width/2,pj.getPageDimension().height/3,null);
    // end job
    pj.end();

  }

  void btnSave_actionPerformed(ActionEvent e) {

    FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

     f.show();

     if (f.getFile()!=null) {
         barcode.setSize(barcode.getPreferredSize());
         String fi=f.getDirectory()+f.getFile();
         if (!fi.toUpperCase().endsWith("JPG")) fi=fi+".jpg";
         System.out.println(fi);
         ImageEncoder   be=  new ImageEncoder(barcode,"JPEG",fi);

         javax.swing.JOptionPane.showMessageDialog(this,"The JPEG file has been saved. We recommend you to use GIF or PNG formats for scanning purposes. See Documentation.");
       }
  }

  void btnExit_actionPerformed(ActionEvent e) {
      System.exit(0);
  }

}
